#!/usr/bin/env python
#
# Read DS1621 via I2C_TINY_USB adapter
#

import sys
import time
import usb
import i2c_tiny_usb

DS1621_ADDR = 0x48

class Ds1621Device(object) :

    def __init__(self,i2cDev,address) :
	self.i2cDev = i2cDev
	self.handle = i2cDev.handle
	self.address = address

	# Probe DS1621
	if self.i2cDev.i2cProbe(self.address) == True:
		print "DS1621 detected"

    def setOneShot(self) :
	nBytes = self.i2cDev.i2cWrite(self.address, [0xac, 0x01])
	if self.i2cDev.getStatus()[0] != self.i2cDev.STATUS_ADDRESS_ACK :
	    print "Setting one shot mode failed"

    def getTemperature(self) :
	nBytes = self.i2cDev.i2cWrite(self.address, [0xee])
	#print "start conversion,  nBytes", nBytes

	while True:
	    reqBuffer = self.i2cDev.i2cWriteRestartRead(self.address, [0xac],1)
            if  reqBuffer[0] & 0x80:
		#print "DS1621 ready"
	        break

        # Read temperature
	temp = self.i2cDev.i2cWriteRestartRead(self.address, [0xaa],2)
	return temp[0] + (temp[1]>>7)*0.5

def main(argv=None) :
    i2cTinyUsbDev = i2c_tiny_usb.I2cTinyUsbDevice()
    handle = i2cTinyUsbDev.open()
    #print hex(i2cTinyUsbDev.getFunctionality())

    # Set i2c delay
    i2cTinyUsbDev.setDelay(10)

    ds1621Dev = Ds1621Device(i2cTinyUsbDev,DS1621_ADDR)
    ds1621Dev.setOneShot()
    print "Temperature: %.1f" % ds1621Dev.getTemperature()

if __name__ == "__main__" :
    main()

