#!/usr/bin/env python
#
# Read X24xx EEPROM
#

import sys
import time
import usb
import i2c_tiny_usb

X24XX_ADDR = 0x50

class X24xxDevice(object) :

    def __init__(self,i2cDev,address) :
	self.i2cDev = i2cDev
	self.handle = i2cDev.handle
	self.address = address

	# Probe X24XX
	self.adress = address
	if self.i2cDev.i2cProbe(self.address) == True:
	    self.memsize = 256
	    self.pagesize = 8
	    self.device = "X2402"
	if self.i2cDev.i2cProbe(self.address + 1) == True:
	    self.memsize = 512
	    self.pagesize = 8
	    self.device = "X2404"
	print self.device, "detected"

    def read(self):
	nBytes = self.i2cDev.i2cWrite(self.address, [0x00])
	if self.i2cDev.getStatus()[0] != self.i2cDev.STATUS_ADDRESS_ACK :
	    print "Setting address failed"
	    sys.exit(1)
	len = self.memsize
	dataBuffer = ()
	while len > 0:
		dataBuffer += self.i2cDev.i2cRead(self.address, self.pagesize)
		len -= self.pagesize
	return dataBuffer

def main(argv=None) :
    i2cTinyUsbDev = i2c_tiny_usb.I2cTinyUsbDevice()
    handle = i2cTinyUsbDev.open()

    # Set i2c delay
    i2cTinyUsbDev.setDelay(10)

    x24xxDev = X24xxDevice(i2cTinyUsbDev,X24XX_ADDR)
    data = x24xxDev.read()
    print data

if __name__ == "__main__" :
    main()

